<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>Simulate Single Game</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
    integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
  <link href="https://fonts.googleapis.com/css?family=Crimson+Text:400,700&display=swap" rel="stylesheet">
  <link rel="stylesheet" href="css/styling.min.css" />
</head>

<body class="simulation-form">
  <h1>Simulate Single Games</h1>
  <div class="content">
    <img class="header-icon" src="assets/simulation.svg" />
    <p>
      Simulate a single game by choosing a board and two algorithms. You can then see the
      move of each player on the board.
    </p>
    <div class="boards">
      <h2>Select Board</h2>
      <div class="card-wrapper">
        <div class="card" id="tic-tac-toe" onclick="selectTicTacToe();" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Tic Tac Toe</h5>
            <p class="card-text">A board with 3x3 fields, where any player can access every empty field at any time. The
              game is won by the player who has three connected fields vertically, horizontally or diagonally.<br /><br />The depth (number of simulated moves) is set to the maximum of the number of available fields.</p>
          </div>
        </div>
        <div class="card" id="connect-four" onclick="selectConnectFour();" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Connect Four</h5>
            <p class="card-text">A board with 7x6 fields, where players can only access fields if the field below is
              already occupied by any other player (this excludes the first row). The game is won by the player who has
              four connected fields vertically, horizontally or diagonally.<br /><br />The depth (number of simulated moves) is set to 4.</p>
          </div>
        </div>
      </div>
    </div>
    <div class="algorithms">
      <h2>Select Algorithm For Player A</h2>
      <div class="card-wrapper">
        <div class="card" id="random-a" onclick="selectRandomForA()" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Random</h5>
            <p class="card-text">This algorithm simply picks a random, accessible field.</p>
          </div>
        </div>
        <div class="card" id="minimax-a" onclick="selectMinimaxForA()" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Minimax</h5>
            <p class="card-text">The minimax method utilises a score that one player tries to minimise while the other
              aims to maximise it. If a player uses the minimax method, it looks at the next n moves and all possible
              game
              states S after each move. It assumes that the opponent tries to minimise the score and then makes the move
              that should result in the overall highest score after all n moves. <br /><br />
              For Tic Tac Toe the number of next
              moves
              is the number of available fields. For Connect Four, the number of next moves is limited to a maximum of
              three. Due to the broad set of possibilities to evaluate this algorithm may take a long time.</p>
          </div>
        </div>
        <div class="card" id="alpha-beta-pruning-a" onclick="selectAlphaBetaPruningForA()" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Alpha Beta Pruning</h5>
            <p class="card-text">This algorithm is an optimisation of the minimax method. Rather than looking at all
              possible game states the algorithm ignores certain game states, that have no chances of being selected.
              This
              is done by keeping track of already visited nodes (possible moves).<br /><br /> Even though this method
              does not
              evaluate as many game states as the minimax method, it may still take a long time to process.
            </p>
          </div>
        </div>
        <div class="card" id="genetic-minimax-a" onclick="selectGeneticMinimaxForA()" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Genetic Minimax</h5>
            <p class="card-text">In games, time is usually a constraining factor that might not allow for the use of the
              minimax or alpha-beta pruning algorithm. For complex problems with a large set of possible solutions, it
              is
              sometimes better to make random decisions instead of evaluating all possible nodes. Genetic (or
              evolutionary) algorithms make use of that. They start with a random set of solutions and evolve this
              population over n generations. <br /><br />The genetic minimax method does that and evaluates the
              population using the
              central concept of the minimax algorithm. While it may not always find the best solution, it may find a
              near
              best solution in a shorter period.</p>
          </div>
        </div>
      </div>
    </div>
    <div class="algorithms">
      <h2>Select Algorithm For Player B</h2>
      <div class="card-wrapper">
        <div class="card" id="random-b" onclick="selectRandomForB()" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Random</h5>
            <p class="card-text">This algorithm simply picks a random, accessible field.</p>
          </div>
        </div>
        <div class="card" id="minimax-b" onclick="selectMinimaxForB()" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Minimax</h5>
            <p class="card-text">The minimax method utilises a score that one player tries to minimise while the other
              aims to maximise it. If a player uses the minimax method, it looks at the next n moves and all possible
              game
              states S after each move. It assumes that the opponent tries to minimise the score and then makes the move
              that should result in the overall highest score after all n moves. <br /><br />
              For Tic Tac Toe the number of next
              moves
              is the number of available fields. For Connect Four, the number of next moves is limited to a maximum of
              three. Due to the broad set of possibilities to evaluate this algorithm may take a long time.</p>
          </div>
        </div>
        <div class="card" id="alpha-beta-pruning-b" onclick="selectAlphaBetaPruningForB()" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Alpha Beta Pruning</h5>
            <p class="card-text">This algorithm is an optimisation of the minimax method. Rather than looking at all
              possible game states the algorithm ignores certain game states, that have no chances of being selected.
              This
              is done by keeping track of already visited nodes (possible moves).<br /><br /> Even though this method
              does not
              evaluate as many game states as the minimax method, it may still take a long time to process.
            </p>
          </div>
        </div>
        <div class="card" id="genetic-minimax-b" onclick="selectGeneticMinimaxForB()" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Genetic Minimax</h5>
            <p class="card-text">In games, time is usually a constraining factor that might not allow for the use of the
              minimax or alpha-beta pruning algorithm. For complex problems with a large set of possible solutions, it
              is
              sometimes better to make random decisions instead of evaluating all possible nodes. Genetic (or
              evolutionary) algorithms make use of that. They start with a random set of solutions and evolve this
              population over n generations. <br /><br />The genetic minimax method does that and evaluates the
              population using the
              central concept of the minimax algorithm. While it may not always find the best solution, it may find a
              near
              best solution in a shorter period.</p>
          </div>
        </div>
      </div>
    </div>
    <div class="start-game">
      <button onclick="startBulkSimulation()" class="btn">Start Simulation</button>
    </div>

    <script>
      let board = undefined;
      let algorithmA = undefined;
      let algorithmB = undefined;
      const numberOfGames = 0;

      function selectTicTacToe() {
        board = 'TIC_TAC_TOE';
        togleBoards('tic-tac-toe');
      }

      function selectConnectFour() {
        board = 'CONNECT_FOUR';
        togleBoards('connect-four');
      }

      function togleBoards(newBoardId) {
        document.getElementById('tic-tac-toe').classList.remove("selected");
        document.getElementById('connect-four').classList.remove("selected");
        document.getElementById(newBoardId).classList.add("selected");
      }

      function selectRandomForA() {
        algorithmA = 'RANDOM';
        toggleA('random-a');
      }

      function selectMinimaxForA() {
        algorithmA = 'MINIMAX';
        toggleA('minimax-a');
      }

      function selectAlphaBetaPruningForA() {
        algorithmA = 'ALPHA_BETA_PRUNING';
        toggleA('alpha-beta-pruning-a');
      }

      function selectGeneticMinimaxForA() {
        algorithmA = 'GENETIC_MINIMAX';
        toggleA('genetic-minimax-a');
      }

      function selectRandomForB() {
        algorithmB = 'RANDOM';
        toggleB('random-b');
      }

      function selectMinimaxForB() {
        algorithmB = 'MINIMAX';
        toggleB('minimax-b');
      }

      function selectAlphaBetaPruningForB() {
        algorithmB = 'ALPHA_BETA_PRUNING';
        toggleB('alpha-beta-pruning-b');
      }

      function selectGeneticMinimaxForB() {
        algorithmB = 'GENETIC_MINIMAX';
        toggleB('genetic-minimax-b');
      }

      function togleBoards(newBoardId) {
        document.getElementById('tic-tac-toe').classList.remove("selected");
        document.getElementById('connect-four').classList.remove("selected");
        document.getElementById(newBoardId).classList.add("selected");
      }

      function toggleA(newAlgorithmId) {
        document.getElementById('random-a').classList.remove("selected");
        document.getElementById('minimax-a').classList.remove("selected");
        document.getElementById('alpha-beta-pruning-a').classList.remove("selected");
        document.getElementById('genetic-minimax-a').classList.remove("selected");
        document.getElementById(newAlgorithmId).classList.add("selected");
      }

      function toggleB(newAlgorithmId) {
        document.getElementById('random-b').classList.remove("selected");
        document.getElementById('minimax-b').classList.remove("selected");
        document.getElementById('alpha-beta-pruning-b').classList.remove("selected");
        document.getElementById('genetic-minimax-b').classList.remove("selected");
        document.getElementById(newAlgorithmId).classList.add("selected");
      }

      function startBulkSimulation() {
        if (numberOfGames === undefined || numberOfGames === '' || board === undefined || algorithmA === undefined ||
          algorithmB === undefined) {
          alert('Check Selection, something is missing');
        } else {
          console.log(numberOfGames, board, algorithmA, algorithmB);
          const url = 'simulate-single-game.html?board=' + board + '&a=' + algorithmA + '&b=' + algorithmB + '&g=' +
            numberOfGames;
          window.location.href = url;
        }
      }
    </script>
</body>

</html>